Index: /trunk/IPs/systemC/Environment/include/Environment.h
===================================================================
--- /trunk/IPs/systemC/Environment/include/Environment.h	(revision 87)
+++ /trunk/IPs/systemC/Environment/include/Environment.h	(revision 88)
@@ -20,6 +20,6 @@
 namespace environment {
 
-  typedef Respons<Ticache_context_t, Ticache_packet_t,Ticache_error_t> irsp_t;
-  typedef Respons<Tdcache_context_t, Tdcache_packet_t,Tdcache_error_t> drsp_t;
+  typedef Respons<morpheo::Ticache_context_t, morpheo::Ticache_packet_t,morpheo::Ticache_error_t> irsp_t;
+  typedef Respons<morpheo::Tdcache_context_t, morpheo::Tdcache_packet_t,morpheo::Tdcache_error_t> drsp_t;
 
   class Environment : public sc_module
@@ -29,38 +29,38 @@
   public : sc_in<bool>                      * NRESET                ;
 
-  public : sc_in <Tcontrol_t           >  *** ICACHE_REQ_VAL        ;
-  public : sc_out<Tcontrol_t           >  *** ICACHE_REQ_ACK        ;
-  public : sc_in <Ticache_context_t    >  *** ICACHE_REQ_CONTEXT_ID ;
-  public : sc_in <Ticache_packet_t     >  *** ICACHE_REQ_PACKET_ID  ;
-  public : sc_in <Ticache_address_t    >  *** ICACHE_REQ_ADDRESS    ;
-  public : sc_in <Ticache_type_t       >  *** ICACHE_REQ_TYPE       ;
+  public : sc_in <morpheo::Tcontrol_t           >  *** ICACHE_REQ_VAL        ;//[nb_entity][icache_dedicated_nb_port]
+  public : sc_out<morpheo::Tcontrol_t           >  *** ICACHE_REQ_ACK        ;//[nb_entity][icache_dedicated_nb_port]
+  public : sc_in <morpheo::Ticache_context_t    >  *** ICACHE_REQ_CONTEXT_ID ;//[nb_entity][icache_dedicated_nb_port]
+  public : sc_in <morpheo::Ticache_packet_t     >  *** ICACHE_REQ_PACKET_ID  ;//[nb_entity][icache_dedicated_nb_port]
+  public : sc_in <morpheo::Ticache_address_t    >  *** ICACHE_REQ_ADDRESS    ;//[nb_entity][icache_dedicated_nb_port]
+  public : sc_in <morpheo::Ticache_type_t       >  *** ICACHE_REQ_TYPE       ;//[nb_entity][icache_dedicated_nb_port]
 
-  public : sc_out<Tcontrol_t           >  *** ICACHE_RSP_VAL        ;
-  public : sc_in <Tcontrol_t           >  *** ICACHE_RSP_ACK        ;
-  public : sc_out<Ticache_context_t    >  *** ICACHE_RSP_CONTEXT_ID ;
-  public : sc_out<Ticache_packet_t     >  *** ICACHE_RSP_PACKET_ID  ;
-  public : sc_out<Ticache_instruction_t> **** ICACHE_RSP_INSTRUCTION;//[nb_instruction]
-  public : sc_out<Ticache_error_t      >  *** ICACHE_RSP_ERROR      ;
+  public : sc_out<morpheo::Tcontrol_t           >  *** ICACHE_RSP_VAL        ;//[nb_entity][icache_dedicated_nb_port]
+  public : sc_in <morpheo::Tcontrol_t           >  *** ICACHE_RSP_ACK        ;//[nb_entity][icache_dedicated_nb_port]
+  public : sc_out<morpheo::Ticache_context_t    >  *** ICACHE_RSP_CONTEXT_ID ;//[nb_entity][icache_dedicated_nb_port]
+  public : sc_out<morpheo::Ticache_packet_t     >  *** ICACHE_RSP_PACKET_ID  ;//[nb_entity][icache_dedicated_nb_port]
+  public : sc_out<morpheo::Ticache_instruction_t> **** ICACHE_RSP_INSTRUCTION;//[nb_entity][icache_dedicated_nb_port][iaccess_nb_instruction]
+  public : sc_out<morpheo::Ticache_error_t      >  *** ICACHE_RSP_ERROR      ;//[nb_entity][icache_dedicated_nb_port]
 
-  public : sc_in <Tcontrol_t           >  *** DCACHE_REQ_VAL        ;
-  public : sc_out<Tcontrol_t           >  *** DCACHE_REQ_ACK        ;
-  public : sc_in <Tdcache_context_t    >  *** DCACHE_REQ_CONTEXT_ID ;
-  public : sc_in <Tdcache_packet_t     >  *** DCACHE_REQ_PACKET_ID  ;
-  public : sc_in <Tdcache_address_t    >  *** DCACHE_REQ_ADDRESS    ;
-  public : sc_in <Tdcache_type_t       >  *** DCACHE_REQ_TYPE       ;
-  public : sc_in <Tdcache_data_t       >  *** DCACHE_REQ_WDATA      ;
+  public : sc_in <morpheo::Tcontrol_t           >  *** DCACHE_REQ_VAL        ;//[nb_entity][dcache_dedicated_nb_port]
+  public : sc_out<morpheo::Tcontrol_t           >  *** DCACHE_REQ_ACK        ;//[nb_entity][dcache_dedicated_nb_port]
+  public : sc_in <morpheo::Tdcache_context_t    >  *** DCACHE_REQ_CONTEXT_ID ;//[nb_entity][dcache_dedicated_nb_port]
+  public : sc_in <morpheo::Tdcache_packet_t     >  *** DCACHE_REQ_PACKET_ID  ;//[nb_entity][dcache_dedicated_nb_port]
+  public : sc_in <morpheo::Tdcache_address_t    >  *** DCACHE_REQ_ADDRESS    ;//[nb_entity][dcache_dedicated_nb_port]
+  public : sc_in <morpheo::Tdcache_type_t       >  *** DCACHE_REQ_TYPE       ;//[nb_entity][dcache_dedicated_nb_port]
+  public : sc_in <morpheo::Tdcache_data_t       >  *** DCACHE_REQ_WDATA      ;//[nb_entity][dcache_dedicated_nb_port]
 
-  public : sc_out<Tcontrol_t           >  *** DCACHE_RSP_VAL        ;
-  public : sc_in <Tcontrol_t           >  *** DCACHE_RSP_ACK        ;
-  public : sc_out<Tdcache_context_t    >  *** DCACHE_RSP_CONTEXT_ID ;
-  public : sc_out<Tdcache_packet_t     >  *** DCACHE_RSP_PACKET_ID  ;
-  public : sc_out<Tdcache_data_t       >  *** DCACHE_RSP_RDATA      ;
-  public : sc_out<Tdcache_error_t      >  *** DCACHE_RSP_ERROR      ;
+  public : sc_out<morpheo::Tcontrol_t           >  *** DCACHE_RSP_VAL        ;//[nb_entity][dcache_dedicated_nb_port]
+  public : sc_in <morpheo::Tcontrol_t           >  *** DCACHE_RSP_ACK        ;//[nb_entity][dcache_dedicated_nb_port]
+  public : sc_out<morpheo::Tdcache_context_t    >  *** DCACHE_RSP_CONTEXT_ID ;//[nb_entity][dcache_dedicated_nb_port]
+  public : sc_out<morpheo::Tdcache_packet_t     >  *** DCACHE_RSP_PACKET_ID  ;//[nb_entity][dcache_dedicated_nb_port]
+  public : sc_out<morpheo::Tdcache_data_t       >  *** DCACHE_RSP_RDATA      ;//[nb_entity][dcache_dedicated_nb_port]
+  public : sc_out<morpheo::Tdcache_error_t      >  *** DCACHE_RSP_ERROR      ;//[nb_entity][dcache_dedicated_nb_port]
 
     // ===== [ Internal ]====================================================
-  public : Tcontrol_t                      ** icache_req_ack        ;
-  public : Tcontrol_t                      ** icache_rsp_val        ;
-  public : Tcontrol_t                      ** dcache_req_ack        ;
-  public : Tcontrol_t                      ** dcache_rsp_val        ;
+  public : morpheo::Tcontrol_t                      ** icache_req_ack        ;
+  public : morpheo::Tcontrol_t                      ** icache_rsp_val        ;
+  public : morpheo::Tcontrol_t                      ** dcache_req_ack        ;
+  public : morpheo::Tcontrol_t                      ** dcache_rsp_val        ;
 
     // ===== [ Variables ]===================================================
@@ -68,7 +68,11 @@
   private  : Parameters         * param;
 
-  private: char **                read_iram;
-  private: char **                read_dram;
-  private: char *                 write_dram;
+  private  : char              ** read_iram;
+  private  : char              ** read_dram;
+  private  : char               * write_dram;
+
+  private  : bool               * context_stop;    // to determine which context have send the signal stop (a same thread can send many signal)
+  private  : uint32_t             nb_context_stop; // stop the simulation when all context have send the stop signal 
+
 
     // ===== [ Components ]==================================================
@@ -88,9 +92,11 @@
   public   : ~Environment (void);
 
-  public   : bool   init       (std::string section, const char * filename, const char ** list_section);
-  public   : void   reset      (void);
+  public   : bool   init           (std::string section, const char * filename, const char ** list_section);
+  public   : void   reset          (void);
+  public   : void   stop           (uint32_t num_context);
+  public   : bool   simulation_end (void);
 
-  public   : void   transition (void);
-  public   : void   genMoore   (void);
+  public   : void   transition     (void);
+  public   : void   genMoore       (void);
 
   public   : friend std::ostream& operator<< (std::ostream& output, Environment &x);
@@ -137,17 +143,4 @@
     }
   };
-
-
-//   private: bool * context_stop;    // to determine which context have send the signal stop (a same thread can send many signal)
-//   private: uint3  nb_context_stop; // stop the simulation when all context have send the stop signal 
-
-//     //---------------------------------------------------------------------------------------------
-//     //-----[ stop ]--------------------------------------------------------------------------------
-//     //---------------------------------------------------------------------------------------------
-//   public : bool stop ()
-//     {
-//       return (nb_context_stop >= nb_context);
-//     }
-
 };
 
Index: /trunk/IPs/systemC/Environment/include/Environment_Parameters.h
===================================================================
--- /trunk/IPs/systemC/Environment/include/Environment_Parameters.h	(revision 87)
+++ /trunk/IPs/systemC/Environment/include/Environment_Parameters.h	(revision 88)
@@ -8,4 +8,5 @@
 #include "../RamLock/include/RamLock_Parameters.h"
 #include "../Sim2OS/include/Sim2OS_Parameters.h"
+#include "../../processor/Morpheo/Common/include/ToString.h"
 
 namespace environment {
@@ -13,41 +14,41 @@
   class Parameters
   {
-  public : uint32_t    nb_iport;
-  public : uint32_t    nb_dport;
-  public : uint32_t    nb_entity;
-  public : uint32_t  * icache_dedicated_nb_port;
-  public : uint32_t  * dcache_dedicated_nb_port;
-
-  public : uint32_t  * iaccess_nb_context    ;
-  public : uint32_t  * iaccess_nb_packet     ;
-  public : uint32_t  * iaccess_size_address  ;
-  public : uint32_t  * iaccess_nb_instruction;
-  public : uint32_t  * iaccess_size_instruction;
-
-  public : uint32_t  * daccess_nb_context    ;
-  public : uint32_t  * daccess_nb_packet     ;
-  public : uint32_t  * daccess_size_address  ;
-  public : uint32_t  * daccess_size_data     ;
+  public : uint32_t                nb_iport                ;
+  public : uint32_t                nb_dport                ;
+  public : uint32_t                nb_entity               ;
+  public : uint32_t              * icache_dedicated_nb_port; //[nb_entity]
+  public : uint32_t              * dcache_dedicated_nb_port; //[nb_entity]
+                               
+  public : uint32_t              * iaccess_nb_context      ; //[nb_entity]
+  public : uint32_t              * iaccess_nb_packet       ; //[nb_entity]
+  public : uint32_t              * iaccess_size_address    ; //[nb_entity]
+  public : uint32_t              * iaccess_nb_instruction  ; //[nb_entity]
+  public : uint32_t              * iaccess_size_instruction; //[nb_entity]
+                               
+  public : uint32_t              * daccess_nb_context      ; //[nb_entity]
+  public : uint32_t              * daccess_nb_packet       ; //[nb_entity]
+  public : uint32_t              * daccess_size_address    ; //[nb_entity]
+  public : uint32_t              * daccess_size_data       ; //[nb_entity]
 
     // Parameters cache
-  public : cache::Parameters                     * param_cache;
+  public : cache::Parameters     * param_cache             ;
     // Parameters tty
-  public : uint32_t                                nb_component_tty;
-  public : uint32_t                              * tty_address;
-  public : tty::Parameters                      ** param_tty;
+  public : uint32_t                nb_component_tty        ;
+  public : uint32_t              * tty_address             ; //[nb_component_tty]
+  public : tty::Parameters      ** param_tty               ; //[nb_component_tty]
     // Parameters ramlock
-  public : uint32_t                                nb_component_ramlock;
-  public : uint32_t                              * ramlock_address;
-  public : ramlock::Parameters                  ** param_ramlock;
+  public : uint32_t                nb_component_ramlock    ;
+  public : uint32_t              * ramlock_address         ; //[nb_component_ramlock]
+  public : ramlock::Parameters  ** param_ramlock           ; //[nb_component_ramlock]
     // Parameters sim2OS
-  public : uint32_t                                sim2os_address;
-  public : uint32_t                                sim2os_size;
-  public : sim2os::Parameters                    * param_sim2os;
+  public : uint32_t                sim2os_address          ;
+  public : uint32_t                sim2os_size             ;
+  public : sim2os::Parameters    * param_sim2os            ;
     // Parameters data
-  public : data::Parameters                      * param_data;
+  public : data::Parameters      * param_data              ;
 
     // Parameters buffer_respons
-  public : queue::Parameters                    ** param_buffer_irsp;
-  public : queue::Parameters                    ** param_buffer_drsp;
+  public : queue::Parameters    ** param_buffer_irsp       ; //[nb_entity]
+  public : queue::Parameters    ** param_buffer_drsp       ; //[nb_entity]
 
   public : Parameters (// General
@@ -232,4 +233,76 @@
       delete param_cache;
     }
+
+  public : std::string print (uint32_t depth)
+    {
+      std::string tab = std::string(depth,'\t');
+      std::string str = "";
+
+      str+=tab+"nb_entity                    : "+morpheo::toString(nb_entity)+"\n";
+      str+=tab+"nb_iport                     : "+morpheo::toString(nb_iport )+"\n";
+      str+=tab+"nb_dport                     : "+morpheo::toString(nb_dport )+"\n";
+      for (uint32_t i=0; i<nb_entity; ++i)
+        {
+      str+=tab+"ENTITY ["+morpheo::toString(i)+"]\n";
+      str+=tab+"  * icache_dedicated_nb_port : "+morpheo::toString(icache_dedicated_nb_port[i])+"\n";
+      str+=tab+"  * dcache_dedicated_nb_port : "+morpheo::toString(dcache_dedicated_nb_port[i])+"\n";
+      str+=tab+"  * iaccess_nb_context       : "+morpheo::toString(iaccess_nb_context      [i])+"\n";
+      str+=tab+"  * iaccess_nb_packet        : "+morpheo::toString(iaccess_nb_packet       [i])+"\n";
+      str+=tab+"  * iaccess_size_address     : "+morpheo::toString(iaccess_size_address    [i])+"\n";
+      str+=tab+"  * iaccess_nb_instruction   : "+morpheo::toString(iaccess_nb_instruction  [i])+"\n";
+      str+=tab+"  * iaccess_size_instruction : "+morpheo::toString(iaccess_size_instruction[i])+"\n";
+      str+=tab+"  * daccess_nb_context       : "+morpheo::toString(daccess_nb_context      [i])+"\n";
+      str+=tab+"  * daccess_nb_packet        : "+morpheo::toString(daccess_nb_packet       [i])+"\n";
+      str+=tab+"  * daccess_size_address     : "+morpheo::toString(daccess_size_address    [i])+"\n";
+      str+=tab+"  * daccess_size_data        : "+morpheo::toString(daccess_size_data       [i])+"\n";
+        }
+
+      str+=tab+"CACHE\n";
+      str+=param_cache->print(depth+1);
+
+//       str+=tab+"nb_component_tty             : "+morpheo::toString(nb_component_tty           )+"\n";
+//       for (uint32_t i=0; i<nb_component_tty; ++i)
+//         {
+//       str+=tab+"TTY ["+morpheo::toString(i)+"]\n";
+//       str+=tab+"  * tty_address              : "+morpheo::toString(tty_address             [i])+"\n";
+//       str+=param_tty->print(depth+1);
+//         }      
+
+//       str+=tab+"nb_component_ramlock         : "+morpheo::toString(nb_component_ramlock       )+"\n";
+//       for (uint32_t i=0; i<nb_component_ramlock; ++i)
+//         {
+//       str+=tab+"RAMLOCK ["+morpheo::toString(i)+"]\n";
+//       str+=tab+"  * ramlock_address          : "+morpheo::toString(ramlock_address         [i])+"\n";
+//       str+=param_ramlock->print(depth+1);
+//         }      
+
+//       str+=tab+"SIM2OS\n";
+//       str+=tab+"sim2os_address               : "+morpheo::toString(sim2os_address)+"\n";
+//       str+=tab+"sim2os_size                  : "+morpheo::toString(sim2os_size   )+"\n";
+//       str+=param_sim2os->print(depth+1);
+
+//       str+=tab+"DATA\n";
+//       str+=param_data->print(depth+1);
+
+//       for (uint32_t i=0; i<nb_entity; ++i)
+//         {
+//       str+=tab+"BUFFER_IRSP ["+morpheo::toString(i)+"]\n";
+//       str+=param_buffer_irsp[i]_data->print(depth+1);
+//         }
+
+//       for (uint32_t i=0; i<nb_entity; ++i)
+//         {
+//       str+=tab+"BUFFER_DRSP ["+morpheo::toString(i)+"]\n";
+//       str+=param_buffer_drsp[i]_data->print(depth+1);
+//         }
+
+      return str;
+    }
+
+//   public : friend std::ostream& operator<< (std::ostream& output, const Parameters &x)
+//     {
+//       x.print(0);
+//       return output;
+//     }
   };
 
Index: /trunk/IPs/systemC/Environment/include/Types.h
===================================================================
--- /trunk/IPs/systemC/Environment/include/Types.h	(revision 87)
+++ /trunk/IPs/systemC/Environment/include/Types.h	(revision 88)
@@ -2,5 +2,5 @@
 #define ENVIRONMENT_TYPES_H
 
-#include "../../processor/Morpheo/Behavioural/include/Types.h"
+#include "../../processor/Morpheo/TopLevel/include/Types.h"
 #include "../../processor/Morpheo/Behavioural/include/Constants.h"
 #include "../Cache/include/Types.h"
@@ -9,19 +9,20 @@
 {
   
-  typedef morpheo::behavioural::Tcontrol_t            Tcontrol_t           ;
+//   typedef morpheo::behavioural::Tcontrol_t            Tcontrol_t           ;
   
-  typedef morpheo::behavioural::Tcontext_t            Ticache_context_t    ;
-  typedef morpheo::behavioural::Tpacket_t             Ticache_packet_t     ;
-  typedef morpheo::behavioural::Ticache_address_t     Ticache_address_t    ;
-  typedef morpheo::behavioural::Ticache_type_t        Ticache_type_t       ;
-  typedef morpheo::behavioural::Ticache_instruction_t Ticache_instruction_t;
-  typedef morpheo::behavioural::Ticache_error_t       Ticache_error_t      ;
+//   typedef morpheo::behavioural::Tcontext_t            Ticache_context_t    ;
+//   typedef morpheo::behavioural::Tpacket_t             Ticache_packet_t     ;
+//   typedef morpheo::behavioural::Ticache_address_t     Ticache_address_t    ;
+//   typedef morpheo::behavioural::Ticache_type_t        Ticache_type_t       ;
+//   typedef morpheo::behavioural::Ticache_instruction_t Ticache_instruction_t;
+//   typedef morpheo::behavioural::Ticache_error_t       Ticache_error_t      ;
 
-  typedef morpheo::behavioural::Tcontext_t            Tdcache_context_t    ;
-  typedef morpheo::behavioural::Tpacket_t             Tdcache_packet_t     ;
-  typedef morpheo::behavioural::Tdcache_address_t     Tdcache_address_t    ;
-  typedef morpheo::behavioural::Tdcache_type_t        Tdcache_type_t       ;
-  typedef morpheo::behavioural::Tdcache_data_t        Tdcache_data_t       ;
-  typedef morpheo::behavioural::Tdcache_error_t       Tdcache_error_t      ;
+//   typedef morpheo::behavioural::Tcontext_t            Tdcache_context_t    ;
+//   typedef morpheo::behavioural::Tpacket_t             Tdcache_packet_t     ;
+//   typedef morpheo::behavioural::Tdcache_address_t     Tdcache_address_t    ;
+//   typedef morpheo::behavioural::Tdcache_type_t        Tdcache_type_t       ;
+//   typedef morpheo::behavioural::Tdcache_data_t        Tdcache_data_t       ;
+//   typedef morpheo::behavioural::Tdcache_error_t       Tdcache_error_t      ;
+
 };
 #endif
Index: /trunk/IPs/systemC/Environment/selftest/main.cpp
===================================================================
--- /trunk/IPs/systemC/Environment/selftest/main.cpp	(revision 87)
+++ /trunk/IPs/systemC/Environment/selftest/main.cpp	(revision 88)
@@ -4,4 +4,5 @@
 using namespace std;
 using namespace environment;
+using namespace morpheo;
 
 #define _TEST_IMEMORY_ true
@@ -206,5 +207,5 @@
        dcache_miss_penality,
        1                             ,
-//        cache_shared_nb_port          ,
+//     cache_shared_nb_port          ,
        cache_shared_nb_line          ,
        cache_shared_size_line        ,
@@ -218,5 +219,5 @@
        nb_tty,
        name_tty,
-       false,
+       false, // don't execute xtty
        
        nb_component_ramlock,
@@ -458,5 +459,5 @@
 		  ICACHE_REQ_VAL        [i][j]->write((addr < addr_max) and ((rand()%100)<percent_transaction_icache_req));
 		  ICACHE_REQ_CONTEXT_ID [i][j]->write(0);
-		  ICACHE_REQ_ADDRESS    [i][j]->write(addr);
+		  ICACHE_REQ_ADDRESS    [i][j]->write(addr>>2);
 		  ICACHE_REQ_PACKET_ID  [i][j]->write(addr>>2);
 		  ICACHE_REQ_TYPE       [i][j]->write(ICACHE_TYPE_LOAD);
@@ -535,5 +536,5 @@
 	ICACHE_REQ_VAL        [0][0]->write(1);
 	ICACHE_REQ_CONTEXT_ID [0][0]->write(0);
-	ICACHE_REQ_ADDRESS    [0][0]->write(0xe0000000);
+	ICACHE_REQ_ADDRESS    [0][0]->write(0xe0000000>>2);
 	ICACHE_REQ_PACKET_ID  [0][0]->write(21);
 	ICACHE_REQ_TYPE       [0][0]->write(ICACHE_TYPE_LOAD);
@@ -561,5 +562,5 @@
 	ICACHE_REQ_VAL        [0][0]->write(1);
 	ICACHE_REQ_CONTEXT_ID [0][0]->write(0);
-	ICACHE_REQ_ADDRESS    [0][0]->write(0xa0000000);
+	ICACHE_REQ_ADDRESS    [0][0]->write(0xa0000000>>2);
 	ICACHE_REQ_PACKET_ID  [0][0]->write(21);
 	ICACHE_REQ_TYPE       [0][0]->write(ICACHE_TYPE_LOAD);
Index: /trunk/IPs/systemC/Environment/src/Environment.cpp
===================================================================
--- /trunk/IPs/systemC/Environment/src/Environment.cpp	(revision 87)
+++ /trunk/IPs/systemC/Environment/src/Environment.cpp	(revision 88)
@@ -1,3 +1,5 @@
 #include "../include/Environment.h"
+
+using namespace morpheo;
 
 namespace environment {
@@ -60,6 +62,4 @@
 
 
-
-
     for (uint32_t i=0; i<param->nb_entity; i++)
       {
@@ -79,4 +79,8 @@
     read_dram[0] = new char [max_data_size/8];
     write_dram   = new char [max_data_size/8];
+    context_stop = new bool [param->nb_entity];
+    for (uint32_t i=0; i<param->nb_entity; ++i)
+      context_stop [i] = false;
+    nb_context_stop = 0;
 
     // Port 
Index: /trunk/IPs/systemC/Environment/src/Environment_genMoore.cpp
===================================================================
--- /trunk/IPs/systemC/Environment/src/Environment_genMoore.cpp	(revision 87)
+++ /trunk/IPs/systemC/Environment/src/Environment_genMoore.cpp	(revision 88)
@@ -1,3 +1,5 @@
 #include "../include/Environment.h"
+
+using namespace morpheo;
 
 namespace environment {
Index: /trunk/IPs/systemC/Environment/src/Environment_simulation_end.cpp
===================================================================
--- /trunk/IPs/systemC/Environment/src/Environment_simulation_end.cpp	(revision 88)
+++ /trunk/IPs/systemC/Environment/src/Environment_simulation_end.cpp	(revision 88)
@@ -0,0 +1,10 @@
+#include "../include/Environment.h"
+
+namespace environment {
+
+  bool Environment::simulation_end(void)
+  {
+    return (nb_context_stop >= param->nb_entity);
+  }
+
+};
Index: /trunk/IPs/systemC/Environment/src/Environment_stop.cpp
===================================================================
--- /trunk/IPs/systemC/Environment/src/Environment_stop.cpp	(revision 88)
+++ /trunk/IPs/systemC/Environment/src/Environment_stop.cpp	(revision 88)
@@ -0,0 +1,17 @@
+#include "../include/Environment.h"
+
+namespace environment {
+
+  void Environment::stop(uint32_t num_context)
+  {
+    if (context_stop [num_context] == false)
+      {
+        context_stop [num_context] = true;
+        nb_context_stop ++;
+	
+        if (nb_context_stop >= param->nb_entity)
+          sc_stop();
+      }
+  }
+
+};
Index: /trunk/IPs/systemC/Environment/src/Environment_transition.cpp
===================================================================
--- /trunk/IPs/systemC/Environment/src/Environment_transition.cpp	(revision 87)
+++ /trunk/IPs/systemC/Environment/src/Environment_transition.cpp	(revision 88)
@@ -1,3 +1,5 @@
 #include "../include/Environment.h"
+
+using namespace morpheo;
 
 namespace environment {
@@ -43,7 +45,7 @@
 		Ticache_context_t context   = ICACHE_REQ_CONTEXT_ID [i][j]->read();// TODO : test presence
 		Ticache_packet_t  packet    = ICACHE_REQ_PACKET_ID  [i][j]->read();// TODO : test presence
-		Ticache_address_t address   = ICACHE_REQ_ADDRESS    [i][j]->read();
+		Ticache_address_t address   = ICACHE_REQ_ADDRESS    [i][j]->read()<<2;
 		Ticache_type_t    type      = ICACHE_REQ_TYPE       [i][j]->read();
-		uint32_t          size      = param->iaccess_size_address [i]/8;
+		uint32_t          size      = (param->iaccess_size_address [i]+2)/8;
 
 		_cout(ENVIRONMENT," * information\n");
@@ -67,5 +69,5 @@
 		    (entity.segment->getType() == data::TYPE_TARGET_MEMORY))
 		  {
-		    _cout(ENVIRONMENT, " * OK !\n");
+		    _cout(ENVIRONMENT," * OK !\n");
 		    bus_error = false;
 		    uncached  = entity.segment->getUncached();
@@ -73,10 +75,10 @@
 		    if (must_read == true) // Test if must read the ram
 		      {
-			_cout(ENVIRONMENT, "   * must read\n");
+			_cout(ENVIRONMENT,"   * must read\n");
 			// Read all instruction
 			for (unsigned int k=0; k<param->iaccess_nb_instruction[i]; k++)
 			  {
 			    uint32_t addr = address+k*(size);
-			    _cout(ENVIRONMENT, "   * addr : %.8x\n",addr);
+                            _cout(ENVIRONMENT,"   * addr    : %.8x\n",addr);
 
 			    bus_error |= !component_data->read(addr,size,read_iram[k]);
@@ -84,5 +86,12 @@
 			    // Swap if endienness is different
 			    if (endianness::isSameEndianness(context) == false) 
-			      read_iram[k] = endianness::swapBytes(read_iram[k],size,size);
+                              {
+                                read_iram[k] = endianness::swapBytes(read_iram[k],size,size);
+                              }
+
+                            _cout(ENVIRONMENT,"   * inst    :");
+                            for (int32_t cpt=(param->iaccess_size_instruction[context]/8)-1; cpt>=0; --cpt)
+                              _cout(ENVIRONMENT, "%.2x",0xff&static_cast<uint32_t>(read_iram[k][cpt]));
+                            _cout(ENVIRONMENT, "\n");
 			  }
 		      }
@@ -241,14 +250,7 @@
 				       ,static_cast<uint32_t>((wdata>> 0)&0xff)
 				       );
+
+                                stop (context);
 			    
-// 				if (context_stop [context] == false)
-// 				  {
-// 				    context_stop [context] = true;
-// 				    nb_context_stop ++;
-				    
-// 				    if (nb_context_stop >= nb_context)
-// 				      sc_stop();
-// 				  }
-
 				break;
 			      }
@@ -387,5 +389,5 @@
 				  {
 				    // Decomposition en groupe octect
-				    Tdcache_data_t result = (Tdcache_data_t)(component_sim2os->result);
+				    Tdcache_data_t result = static_cast<Tdcache_data_t>(reinterpret_cast<uint64_t>(component_sim2os->result));
 				    _cout(ENVIRONMENT,"<sim2os> result      : %x\n",result);
 				    
@@ -494,5 +496,4 @@
 		    component_buffer_drsp [i]->push(latence,rsp);
 		  }
-
 	      }
 	//=============================================================================
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/Makefile
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/Makefile	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/Makefile	(revision 88)
@@ -0,0 +1,24 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+
+#-----[ Directory ]----------------------------------------
+DIR_COMPONENT			= ./
+include				$(DIR_COMPONENT)/Makefile.defs
+
+#-----[ Library ]------------------------------------------
+LIBRARY				= $(DIR_LIB)/libConfiguration.a
+
+
+#-----[ include ]------------------------------------------
+
+all				:
+				@$(MAKE) all_component
+
+include                         $(DIR_MORPHEO)/Behavioural/Makefile.flags
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Common
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Component
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/Makefile.defs
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/Makefile.defs	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/Makefile.defs	(revision 88)
@@ -0,0 +1,11 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+
+#-----[ Directory ]----------------------------------------
+DIR_COMPONENT_MORPHEO		= ../..
+DIR_MORPHEO			= $(DIR_COMPONENT)/$(DIR_COMPONENT_MORPHEO)
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/Makefile.deps
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/Makefile.deps	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/Makefile.deps	(revision 88)
@@ -0,0 +1,46 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+# DIR_MORPHEO must be defined
+
+Configuration			= yes
+
+ifndef Behavioural
+include 			$(DIR_MORPHEO)/Behavioural/Makefile.deps
+endif
+ifndef Custom
+include 			$(DIR_MORPHEO)/Behavioural/Custom/Makefile.deps
+endif
+
+#-----[ Directory ]----------------------------------------
+
+Configuration_DIR		=	$(DIR_MORPHEO)/Behavioural/Configuration
+
+#-----[ Library ]------------------------------------------
+
+Configuration_LIBRARY		= 	$(Behavioural_LIBRARY)          \
+                                        -lConfiguration                 \
+					$(Custom_LIBRARY)               \
+					$(Behavioural_LIBRARY)
+
+Configuration_DIR_LIBRARY	=	-L$(Configuration_DIR)/lib	\
+					$(Custom_DIR_LIBRARY)           \
+					$(Behavioural_DIR_LIBRARY)
+
+#-----[ Rules ]--------------------------------------------
+
+Configuration_library		:
+				@\
+				$(MAKE) Behavioural_library;		\
+				$(MAKE) Custom_library;		        \
+				$(MAKE) --directory=$(Configuration_DIR) --makefile=Makefile;
+
+Configuration_library_clean	:
+				@\
+				$(MAKE) Behavioural_library_clean;	\
+				$(MAKE) Custom_library_clean;	        \
+				$(MAKE) --directory=$(Configuration_DIR) --makefile=Makefile clean;
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/SelfTest/Makefile
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/SelfTest/Makefile	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/SelfTest/Makefile	(revision 88)
@@ -0,0 +1,34 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+
+#-----[ Directory ]----------------------------------------
+DIR_COMPONENT			= ../
+include				$(DIR_COMPONENT)/Makefile.defs
+
+LIBRARY				= $(Configuration_LIBRARY)
+
+DIR_LIBRARY			= $(Configuration_DIR_LIBRARY)
+
+#-----[ include ]------------------------------------------
+
+all				:
+				@$(MAKE) all_selftest
+
+library				: Configuration_library
+
+library_clean			: Configuration_library_clean
+
+local_clean			:
+				@$(RM) 	data_in/*~ 	\
+					data_out/*
+
+include                         $(DIR_COMPONENT)/Makefile.deps
+include                         $(DIR_MORPHEO)/Behavioural/Makefile.flags
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Common
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Selftest
+include 			$(DIR_MORPHEO)/Behavioural/Makefile.Synthesis
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/SelfTest/include/test.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/SelfTest/include/test.h	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/SelfTest/include/test.h	(revision 88)
@@ -0,0 +1,29 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ * Test "RegisterFile"
+ */
+
+#ifdef SYSTEMC
+#include "systemc.h"
+#endif
+
+#define NB_ITERATION  1
+#define CYCLE_MAX     (1024*NB_ITERATION)
+
+#include "Common/include/Test.h"
+#include "Common/include/Time.h"
+#include "Behavioural/Configuration/include/Configuration.h"
+
+#include <string>
+#include <iostream>
+#include <sys/time.h>
+
+using namespace std;
+using namespace morpheo;
+using namespace morpheo::behavioural;
+using namespace morpheo::behavioural::configuration;
+
+void test    (string name);
